local C = require("classic")
local T = require("toolbox")
local M = require("menu")
local Rat_rider = {}

------------------------------------------------------------------------------------

-- Add menu choise

function menu_item_exists(id)
	for k,v in ipairs(kts.MENU.items) do
		if v.id == id then
			return true
		end
	end
	return false
end



function add_menu_item_after(item_id, old_id)
	if menu_item_exists(old_id) then
		local pos
		for k,v in ipairs(kts.MENU.items) do
			if v.id == old_id then
				pos = k
				break
			end
		end
		table.insert(kts.MENU.items, pos+1, item_id)
	else
		table.insert(kts.MENU.items, item_id)
	end
end



------------------------------------------------------------------------------------

-- Graphics

g_rat_rider_with_sabers_1n = kts.Graphic("sprites/rat_rider_with_sabers_1n.bmp", 255,255,0)
g_rat_rider_with_sabers_1e = kts.Graphic("sprites/rat_rider_with_sabers_1e.bmp", 255,255,0)
g_rat_rider_with_sabers_1s = kts.Graphic("sprites/rat_rider_with_sabers_1s.bmp", 255,255,0)
g_rat_rider_with_sabers_1w = kts.Graphic("sprites/rat_rider_with_sabers_1w.bmp", 255,255,0)
g_rat_rider_with_sabers_2n = kts.Graphic("sprites/rat_rider_with_sabers_2n.bmp", 255,255,0)
g_rat_rider_with_sabers_2e = kts.Graphic("sprites/rat_rider_with_sabers_2e.bmp", 255,255,0)
g_rat_rider_with_sabers_2s = kts.Graphic("sprites/rat_rider_with_sabers_2s.bmp", 255,255,0)
g_rat_rider_with_sabers_2w = kts.Graphic("sprites/rat_rider_with_sabers_2w.bmp", 255,255,0)
g_rat_rider_with_sabers_3n = kts.Graphic("sprites/rat_rider_with_sabers_3n.bmp", 255,255,0, 0,16)
g_rat_rider_with_sabers_3e = kts.Graphic("sprites/rat_rider_with_sabers_3e.bmp", 255,255,0)
g_rat_rider_with_sabers_3s = kts.Graphic("sprites/rat_rider_with_sabers_3s.bmp", 255,255,0)
g_rat_rider_with_sabers_3w = kts.Graphic("sprites/rat_rider_with_sabers_3w.bmp", 255,255,0, 16,0)
g_rat_rider_with_sabers_4n = kts.Graphic("sprites/rat_rider_with_sabers_4n.bmp", 255,255,0)
g_rat_rider_with_sabers_4e = kts.Graphic("sprites/rat_rider_with_sabers_4e.bmp", 255,255,0)
g_rat_rider_with_sabers_4s = kts.Graphic("sprites/rat_rider_with_sabers_4s.bmp", 255,255,0)
g_rat_rider_with_sabers_4w = kts.Graphic("sprites/rat_rider_with_sabers_4w.bmp", 255,255,0)



g_rat_rider_with_lance_1n = kts.Graphic("sprites/rat_rider_with_lance_1n.bmp", 255,255,0)
g_rat_rider_with_lance_1e = kts.Graphic("sprites/rat_rider_with_lance_1e.bmp", 255,255,0)
g_rat_rider_with_lance_1s = kts.Graphic("sprites/rat_rider_with_lance_1s.bmp", 255,255,0)
g_rat_rider_with_lance_1w = kts.Graphic("sprites/rat_rider_with_lance_1w.bmp", 255,255,0)
g_rat_rider_with_lance_2n = kts.Graphic("sprites/rat_rider_with_lance_2n.bmp", 255,255,0)
g_rat_rider_with_lance_2e = kts.Graphic("sprites/rat_rider_with_lance_2e.bmp", 255,255,0)
g_rat_rider_with_lance_2s = kts.Graphic("sprites/rat_rider_with_lance_2s.bmp", 255,255,0)
g_rat_rider_with_lance_2w = kts.Graphic("sprites/rat_rider_with_lance_2w.bmp", 255,255,0)
g_rat_rider_with_lance_3n = kts.Graphic("sprites/rat_rider_with_lance_3n.bmp", 255,255,0, 0,16)
g_rat_rider_with_lance_3e = kts.Graphic("sprites/rat_rider_with_lance_3e.bmp", 255,255,0)
g_rat_rider_with_lance_3s = kts.Graphic("sprites/rat_rider_with_lance_3s.bmp", 255,255,0)
g_rat_rider_with_lance_3w = kts.Graphic("sprites/rat_rider_with_lance_3w.bmp", 255,255,0, 16,0)
g_rat_rider_with_lance_4n = kts.Graphic("sprites/rat_rider_with_lance_4n.bmp", 255,255,0)
g_rat_rider_with_lance_4e = kts.Graphic("sprites/rat_rider_with_lance_4e.bmp", 255,255,0)
g_rat_rider_with_lance_4s = kts.Graphic("sprites/rat_rider_with_lance_4s.bmp", 255,255,0)
g_rat_rider_with_lance_4w = kts.Graphic("sprites/rat_rider_with_lance_4w.bmp", 255,255,0)



g_zombie_with_sabers_1n = kts.Graphic("sprites/zombie_with_sabers_1n.bmp", 255,255,0)
g_zombie_with_sabers_1e = kts.Graphic("sprites/zombie_with_sabers_1e.bmp", 255,255,0)
g_zombie_with_sabers_1s = kts.Graphic("sprites/zombie_with_sabers_1s.bmp", 255,255,0)
g_zombie_with_sabers_1w = kts.Graphic("sprites/zombie_with_sabers_1w.bmp", 255,255,0)
g_zombie_with_sabers_2n = kts.Graphic("sprites/zombie_with_sabers_2n.bmp", 255,255,0)
g_zombie_with_sabers_2e = kts.Graphic("sprites/zombie_with_sabers_2e.bmp", 255,255,0)
g_zombie_with_sabers_2s = kts.Graphic("sprites/zombie_with_sabers_2s.bmp", 255,255,0)
g_zombie_with_sabers_2w = kts.Graphic("sprites/zombie_with_sabers_2w.bmp", 255,255,0)
g_zombie_with_sabers_3n = kts.Graphic("sprites/zombie_with_sabers_3n.bmp", 255,255,0, 0,16)
g_zombie_with_sabers_3e = kts.Graphic("sprites/zombie_with_sabers_3e.bmp", 255,255,0)
g_zombie_with_sabers_3s = kts.Graphic("sprites/zombie_with_sabers_3s.bmp", 255,255,0)
g_zombie_with_sabers_3w = kts.Graphic("sprites/zombie_with_sabers_3w.bmp", 255,255,0, 16,0)
g_zombie_with_sabers_4n = kts.Graphic("sprites/zombie_with_sabers_4n.bmp", 255,255,0)
g_zombie_with_sabers_4e = kts.Graphic("sprites/zombie_with_sabers_4e.bmp", 255,255,0)
g_zombie_with_sabers_4s = kts.Graphic("sprites/zombie_with_sabers_4s.bmp", 255,255,0)
g_zombie_with_sabers_4w = kts.Graphic("sprites/zombie_with_sabers_4w.bmp", 255,255,0)



g_zombie_with_shield_1n = kts.Graphic("sprites/zombie_with_shield_1n.bmp", 255,255,0)
g_zombie_with_shield_1e = kts.Graphic("sprites/zombie_with_shield_1e.bmp", 255,255,0)
g_zombie_with_shield_1s = kts.Graphic("sprites/zombie_with_shield_1s.bmp", 255,255,0)
g_zombie_with_shield_1w = kts.Graphic("sprites/zombie_with_shield_1w.bmp", 255,255,0)
g_zombie_with_shield_2n = kts.Graphic("sprites/zombie_with_shield_2n.bmp", 255,255,0)
g_zombie_with_shield_2e = kts.Graphic("sprites/zombie_with_shield_2e.bmp", 255,255,0)
g_zombie_with_shield_2s = kts.Graphic("sprites/zombie_with_shield_2s.bmp", 255,255,0)
g_zombie_with_shield_2w = kts.Graphic("sprites/zombie_with_shield_2w.bmp", 255,255,0)
g_zombie_with_shield_3n = kts.Graphic("sprites/zombie_with_shield_3n.bmp", 255,255,0, 0,16)
g_zombie_with_shield_3e = kts.Graphic("sprites/zombie_with_shield_3e.bmp", 255,255,0)
g_zombie_with_shield_3s = kts.Graphic("sprites/zombie_with_shield_3s.bmp", 255,255,0)
g_zombie_with_shield_3w = kts.Graphic("sprites/zombie_with_shield_3w.bmp", 255,255,0, 16,0)
g_zombie_with_shield_4n = kts.Graphic("sprites/zombie_with_shield_4n.bmp", 255,255,0)
g_zombie_with_shield_4e = kts.Graphic("sprites/zombie_with_shield_4e.bmp", 255,255,0)
g_zombie_with_shield_4s = kts.Graphic("sprites/zombie_with_shield_4s.bmp", 255,255,0)
g_zombie_with_shield_4w = kts.Graphic("sprites/zombie_with_shield_4w.bmp", 255,255,0)



g_dead_rat_rider_with_sabers_1 = kts.Graphic("sprites/dead_rat_rider_with_sabers_1.bmp", 255,255,0)
g_dead_rat_rider_with_sabers_2 = kts.Graphic("sprites/dead_rat_rider_with_sabers_2.bmp", 255,255,0)
g_dead_rat_rider_with_sabers_3 = kts.Graphic("sprites/dead_rat_rider_with_sabers_3.bmp", 255,255,0)
g_dead_rat_rider_with_sabers_4 = kts.Graphic("sprites/dead_rat_rider_with_sabers_4.bmp", 255,255,0)



g_dead_rat_rider_with_lance_1 = kts.Graphic("sprites/dead_rat_rider_with_lance_1.bmp", 255,255,0)
g_dead_rat_rider_with_lance_2 = kts.Graphic("sprites/dead_rat_rider_with_lance_2.bmp", 255,255,0)
g_dead_rat_rider_with_lance_3 = kts.Graphic("sprites/dead_rat_rider_with_lance_3.bmp", 255,255,0)
g_dead_rat_rider_with_lance_4 = kts.Graphic("sprites/dead_rat_rider_with_lance_4.bmp", 255,255,0)



-- Animation

a_rat_rider_with_sabers = kts.Anim {
	g_rat_rider_with_sabers_1n, g_rat_rider_with_sabers_1e, g_rat_rider_with_sabers_1s, g_rat_rider_with_sabers_1w,
	g_rat_rider_with_sabers_2n, g_rat_rider_with_sabers_2e, g_rat_rider_with_sabers_2s, g_rat_rider_with_sabers_2w,
	g_rat_rider_with_sabers_3n, g_rat_rider_with_sabers_3e, g_rat_rider_with_sabers_3s, g_rat_rider_with_sabers_3w,
	g_rat_rider_with_sabers_4n, g_rat_rider_with_sabers_4e, g_rat_rider_with_sabers_4s, g_rat_rider_with_sabers_4w,
}



a_rat_rider_with_lance = kts.Anim {
	g_rat_rider_with_lance_1n, g_rat_rider_with_lance_1e, g_rat_rider_with_lance_1s, g_rat_rider_with_lance_1w,
	g_rat_rider_with_lance_2n, g_rat_rider_with_lance_2e, g_rat_rider_with_lance_2s, g_rat_rider_with_lance_2w,
	g_rat_rider_with_lance_3n, g_rat_rider_with_lance_3e, g_rat_rider_with_lance_3s, g_rat_rider_with_lance_3w,
	g_rat_rider_with_lance_4n, g_rat_rider_with_lance_4e, g_rat_rider_with_lance_4s, g_rat_rider_with_lance_4w,
}



a_zombie_with_sabers = kts.Anim {
	g_zombie_with_sabers_1n, g_zombie_with_sabers_1e, g_zombie_with_sabers_1s, g_zombie_with_sabers_1w,
	g_zombie_with_sabers_2n, g_zombie_with_sabers_2e, g_zombie_with_sabers_2s, g_zombie_with_sabers_2w,
	g_zombie_with_sabers_3n, g_zombie_with_sabers_3e, g_zombie_with_sabers_3s, g_zombie_with_sabers_3w,
	g_zombie_with_sabers_4n, g_zombie_with_sabers_4e, g_zombie_with_sabers_4s, g_zombie_with_sabers_4w,
}



a_zombie_with_shield = kts.Anim {
	g_zombie_with_shield_1n, g_zombie_with_shield_1e, g_zombie_with_shield_1s, g_zombie_with_shield_1w,
	g_zombie_with_shield_2n, g_zombie_with_shield_2e, g_zombie_with_shield_2s, g_zombie_with_shield_2w,
	g_zombie_with_shield_3n, g_zombie_with_shield_3e, g_zombie_with_shield_3s, g_zombie_with_shield_3w,
	g_zombie_with_shield_4n, g_zombie_with_shield_4e, g_zombie_with_shield_4s, g_zombie_with_shield_4w,
}



-- Tiles

t_dead_rat_rider_with_sabers_1 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_sabers_1, depth = -1 })
t_dead_rat_rider_with_sabers_2 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_sabers_2, depth = -1 })
t_dead_rat_rider_with_sabers_3 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_sabers_3, depth = -1 })
t_dead_rat_rider_with_sabers_4 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_sabers_4, depth = -1 })



t_dead_rat_rider_with_lance_1 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_lance_1, depth = -1 })
t_dead_rat_rider_with_lance_2 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_lance_2, depth = -1 })
t_dead_rat_rider_with_lance_3 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_lance_3, depth = -1 })
t_dead_rat_rider_with_lance_4 = kts.Tile(C.floor & { graphic = g_dead_rat_rider_with_lance_4, depth = -1 })



--Sounds

s_charge_sound = kts.Sound("Sounds/Roar.wav")



------------------------------------------------------------------------------------

-- Function

function PARRYvsCHARGE()
	for i = 1, #Rat_rider do
		if (cxt.actor_pos.x - Rat_rider[i][6].x == 1 and kts.GetFacing(cxt.actor) == 'west' and kts.GetFacing(Rat_rider[i][1]) == 'east') or (cxt.actor_pos.x - Rat_rider[i][6].x == -1 and kts.GetFacing(cxt.actor) == 'east' and kts.GetFacing(Rat_rider[i][1]) == 'west') or (cxt.actor_pos.y - Rat_rider[i][6].y == 1 and kts.GetFacing(cxt.actor) == 'north' and kts.GetFacing(Rat_rider[i][1]) == 'south') or (cxt.actor_pos.y - Rat_rider[i][6].y == -1 and kts.GetFacing(cxt.actor) == 'south' and kts.GetFacing(Rat_rider[i][1]) == 'north') then
			if Rat_rider[i][3] >= 3 and kts.GetFacing(Rat_rider[i][1]) == Rat_rider[i][2] then
				if Rat_rider[i][5] == 'saber' then
					kts.Damage(1, 0.5)
				else
					kts.Damage(6, 0.5)
				end
				C.snd_parry()
				kts.PlaySound(cxt.pos, s_charge_sound, 12000)
			end
			Rat_rider[i][3] = 0
			break
		end
	end
end



function charge()
	for i = 1, #Rat_rider do
		if cxt.actor == Rat_rider[i][1] then
			local sound = true
			local actor = cxt.actor
			cxt.actor = cxt.victim
			if Rat_rider[i][3] == 1 and kts.GetFacing(Rat_rider[i][1]) == Rat_rider[i][2] then
				if Rat_rider[i][5] == 'lance' then kts.Damage(1, 0.1)
				end
			end
			if Rat_rider[i][3] == 2 and kts.GetFacing(Rat_rider[i][1]) == Rat_rider[i][2] then
				if Rat_rider[i][5] == 'lance' then kts.Damage(2, 0.5)
				end
			end
			if Rat_rider[i][3] >= 3 and kts.GetFacing(Rat_rider[i][1]) == Rat_rider[i][2] then
				local damage = 0
				if Rat_rider[i][5] == 'saber' then 
					damage = C.rng_range(2,4)
					kts.Damage(damage(), 0.5)
				else 
					damage = C.rng_range(6,9)
					kts.Damage(damage(), 1)
				end
				cxt.actor = actor
				kts.PlaySound(cxt.pos, s_charge_sound, 12000)
				sound = false
			end
			cxt.actor = actor
			if sound then C.snd_zombie() end
			Rat_rider[i][3] = 0
			break
		end
	end
end



function move(weapon)
	if #Rat_rider == 0 then
		table.insert(Rat_rider, {cxt.actor, 'north', 0, false, weapon, cxt.actor_pos})
	else
		local not_found = true
		for i = 1, #Rat_rider do
			if cxt.actor == Rat_rider[i][1] then
				Rat_rider[i][6] = cxt.actor_pos
				not_found = false
				if Rat_rider[i][3] == 0 then
					Rat_rider[i][3] = 1
					Rat_rider[i][2] = kts.GetFacing(Rat_rider[i][1])
				else
					if kts.GetFacing(Rat_rider[i][1]) == Rat_rider[i][2] then
						Rat_rider[i][3] = Rat_rider[i][3] + 1
					else
						Rat_rider[i][3] = 1
						Rat_rider[i][2] = kts.GetFacing(Rat_rider[i][1])
					end
					if Rat_rider[i][4] then 
						Rat_rider[i][3] = 1
						Rat_rider[i][4] = false
					end
				end
				break
			end
		end
		if not_found then
			table.insert(Rat_rider, {cxt.actor, 'north', 0, false, weapon, cxt.actor_pos})
		end
	end
end



------------------------------------------------------------------------------------

-- The monster types

rat_rider_sabers = kts.ItemType {
	type = "held",
	melee_backswing_time = 1.5*C.ts,
	melee_downswing_time = 2.5*C.ts,
	melee_damage         = C.rng_range(1,2),
	melee_stun_time      = C.rng_time_range(1,4),
	melee_tile_damage    = 1,
	melee_action		 = charge
}



rat_rider_lance = kts.ItemType {
	type = "held",	
	melee_backswing_time = 3.5*C.ts,
	melee_downswing_time = 3*C.ts,
	melee_damage         = 1,
	melee_stun_time      = C.rng_time_range(3,6),
	melee_tile_damage    = 2,
	melee_action		 = charge,
	parry_chance		 = 1
}



double_sabers = kts.ItemType {
	type = "held",
	melee_backswing_time = 1.5*C.ts,
	melee_downswing_time = 2.5*C.ts,
	melee_damage         = C.rng_range(1,2),
	melee_stun_time      = C.rng_time_range(1,4),
	melee_tile_damage    = 1,
}



sword_and_shield = kts.ItemType {
	type = "held",	
	melee_backswing_time = 3*C.ts,
	melee_downswing_time = 3*C.ts,
	melee_damage         = C.rng_range(1,3),
	melee_stun_time      = C.rng_time_range(2,5),
	melee_tile_damage    = 3,
	parry_chance		 = 1
}



rat_rider_with_sabers = {
	type = "walking",
	
	health       = C.rng_range(4,5),
    speed        = 120,
	anim         = a_rat_rider_with_sabers,
	corpse_tiles = { t_dead_rat_rider_with_sabers_1,t_dead_rat_rider_with_sabers_2,t_dead_rat_rider_with_sabers_3,t_dead_rat_rider_with_sabers_4 },
	weapon       = rat_rider_sabers,
	
	on_attack = function()
		for i = 1, #Rat_rider do
			if cxt.actor == Rat_rider[i][1] then
				Rat_rider[i][6] = cxt.actor_pos
				if Rat_rider[i][4] then 
					Rat_rider[i][3] = 0
				end
				Rat_rider[i][4] = true
				break
			end
		end
	end,
	
	on_damage = function()
		C.snd_zombie()
		for i = 1, #Rat_rider do
			if cxt.actor == Rat_rider[i][1] then
				Rat_rider[i][3] = 0
				break
			end
		end
	end,
	
	on_death = function()
		C.snd_zombie()
		local pos = kts.GetPos(cxt.actor)
		kts.Delay(10)
		local zombie = kts.AddMonster(pos, m_zombie_with_sabers)
		cxt.actor = zombie
		kts.Delay(200)
	end,
	
	on_move = function()
		move('saber')
		if kts.RandomChance(0.05) then
			C.snd_zombie()
		end
	end,


	ai_avoid     = C.all_open_pit_tiles,
	ai_hit       = {C.i_bear_trap_open},
	ai_fear      = {C.i_wand_of_undeath},
}



rat_rider_with_lance = {
	type = "walking",
	
	health       = C.rng_range(4,5),
    speed        = 120,
	anim         = a_rat_rider_with_lance,
	corpse_tiles = { t_dead_rat_rider_with_lance_1,t_dead_rat_rider_with_lance_2,t_dead_rat_rider_with_lance_3,t_dead_rat_rider_with_lance_4 },
	weapon       = rat_rider_lance,
	
	on_attack = function()
		for i = 1, #Rat_rider do
			if cxt.actor == Rat_rider[i][1] then
				Rat_rider[i][6] = cxt.actor_pos
				if Rat_rider[i][4] then 
					Rat_rider[i][3] = 0
				end
				Rat_rider[i][4] = true
				break
			end
		end
	end,
	
	on_damage = function()
		C.snd_zombie()
		for i = 1, #Rat_rider do
			if cxt.actor == Rat_rider[i][1] then
				Rat_rider[i][3] = 0
				break
			end
		end
	end,
	
	on_death = function()
		C.snd_zombie()
		local pos = kts.GetPos(cxt.actor)
		kts.Delay(10)
		local zombie = kts.AddMonster(pos, m_zombie_with_shield)
		cxt.actor = zombie
		kts.Delay(100)
	end,
	
	on_move = function()
		move('lance')
		if kts.RandomChance(0.05) then
			C.snd_zombie()
		end
	end,


	ai_avoid     = C.all_open_pit_tiles,
	ai_hit       = {C.i_bear_trap_open},
	ai_fear      = {C.i_wand_of_undeath},
}



zombie_with_sabers = {
	type = "walking",
	health = C.rng_range(2,6),
	speed = 60,
	anim = a_zombie_with_sabers,
	corpse_tiles = {C.t_dead_zombie},
	weapon = double_sabers,
	
	on_attack = snd_zombie,
	on_damage = snd_zombie,
	on_death = snd_zombie,
	on_move = function()
		if kts.RandomChance(0.05) then C.snd_zombie()
		end
	end,
	
	ai_avoid = C.all_open_pit_tiles,
	ai_hit = {C.i_bear_trap_open},
	ai_fear = {C.i_wand_of_undeath}
}



zombie_with_shield = {
	type = "walking",
	health = C.rng_range(2,6),
	speed = 60,
	anim = a_zombie_with_shield,
	corpse_tiles = {C.t_dead_zombie},
	weapon = sword_and_shield,
	
	on_attack = snd_zombie,
	on_damage = snd_zombie,
	on_death = snd_zombie,
	on_move = function()
		if kts.RandomChance(0.05) then C.snd_zombie()
		end
	end,
	
	ai_avoid = C.all_open_pit_tiles,
	ai_hit = {C.i_bear_trap_open},
	ai_fear = {C.i_wand_of_undeath}
}



m_zombie_with_sabers = kts.MonsterType(zombie_with_sabers)
m_zombie_with_shield = kts.MonsterType(zombie_with_shield)



m_rat_rider_with_sabers   = kts.MonsterType(rat_rider_with_sabers)
m_rat_rider_with_lance   = kts.MonsterType(rat_rider_with_lance)

Rat_riders    = {m_rat_rider_with_sabers, m_rat_rider_with_lance}
Rat_rider_chances = {1, 2}



rat_rider_item = { 
	id         = "rat_rider",
	text       = "Rat rider",
	choice_min = 0,
	choice_max = 5,
	features   = function(S)
	if S.rat_rider > 0 then
		T.RegisterHook("WEAPON_PARRY","rat_riders_weapon_parry",PARRYvsCHARGE)
		for i=1, 2*S.rat_rider do
			local temp = kts.RandomRange(1, #Rat_rider_chances)
			C.add_initial_monsters(Rat_riders[Rat_rider_chances[temp]], 1)
		end
	else T.DeleteHook("WEAPON_PARRY","rat_riders_weapon_parry")
	end
end,
}



add_menu_item_after(rat_rider_item, "bats")